searchNodes=[{"doc":"Localized metrics reporter","ref":"Mobius.html","title":"Mobius","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mobius.html#child_spec/1","title":"Mobius.child_spec/1","type":"function"},{"doc":"Get the current metric information If you configured Mobius to use a different name then you can pass in your custom name to ensure Mobius requests the metrics from the right place.","ref":"Mobius.html#info/0","title":"Mobius.info/0","type":"function"},{"doc":"","ref":"Mobius.html#info/1","title":"Mobius.info/1","type":"function"},{"doc":"Persist the metrics to disk","ref":"Mobius.html#save/0","title":"Mobius.save/0","type":"function"},{"doc":"","ref":"Mobius.html#save/1","title":"Mobius.save/1","type":"function"},{"doc":"Start Mobius","ref":"Mobius.html#start_link/1","title":"Mobius.start_link/1","type":"function"},{"doc":"Arguments to Mobius :name - the name of the mobius instance (defaults to :mobius ) :metrics - list of telemetry metrics for Mobius to track :persistence_dir - the top level directory where mobius will persist :autosave_interval - time in seconds between automatic writes of the persistence data (default disabled) metric information :database - the Mobius.RRD.t() to use. This will default to the the default values found in Mobius.RRD","ref":"Mobius.html#t:arg/0","title":"Mobius.arg/0","type":"type"},{"doc":"The name of the Mobius instance This is used to store data for a particular set of mobius metrics.","ref":"Mobius.html#t:instance/0","title":"Mobius.instance/0","type":"type"},{"doc":"A single metric data point :type - the type of the metric :value - the value of the measurement for the metric :tags - a map of the tags for the metric :timestamp - the naive time in seconds the metric was sampled :name - the name of the metric","ref":"Mobius.html#t:metric/0","title":"Mobius.metric/0","type":"type"},{"doc":"The name of the metric Example: &quot;vm.memory.total&quot;","ref":"Mobius.html#t:metric_name/0","title":"Mobius.metric_name/0","type":"type"},{"doc":"","ref":"Mobius.html#t:metric_type/0","title":"Mobius.metric_type/0","type":"type"},{"doc":"","ref":"Mobius.html#t:time_unit/0","title":"Mobius.time_unit/0","type":"type"},{"doc":"","ref":"Mobius.html#t:timestamp/0","title":"Mobius.timestamp/0","type":"type"},{"doc":"Support retrieving historical data in different formats Current formats: CSV Series Line plot Mobius Binary Format (MBF) The Mobius Binary Format (MBF) is a format that contains the current state of all metrics. This binary format is useful for transfer metric information in a useful format to another services to parse and use. For more details see mbf/1 .","ref":"Mobius.Exports.html","title":"Mobius.Exports","type":"module"},{"doc":"Generate a CSV for the metric Please see Mobius.Exporters.CSV for more information. # Return CSV as string { :ok , csv_string } = Mobius.Exports . csv ( &quot;vm.memory.total&quot; , :last_value , %{ } ) # Write to console Mobius.Exports . csv ( &quot;vm.memory.total&quot; , :last_value , %{ } , iodevice : :stdio ) #Write to a file file = File . open ( &quot;mycsv.csv&quot; , [ :write ] ) :ok = Mobius.Exports . csv ( &quot;vm.memory.total&quot; , :last_value , %{ } , iodevice : file )","ref":"Mobius.Exports.html#csv/4","title":"Mobius.Exports.csv/4","type":"function"},{"doc":"Export all metrics in the Mobius Binary Format (MBF) This is most useful for when you want to share metric data to different networked services. The binary format is &lt;&lt;version, metric_data::binary&gt;&gt; The first byte is the version number of the following metric data. Currently, the version number is 1 . The metric data binary is the type of [Mobius.metric()] encoded in Binary ERlang Term format (BERT) and compressed (using Zlib compression). Optionally, to_mbf/1 can write the binary to a file using the :out_dir option. Mobius.Exports . to_mbf ( out_dir : &quot;/my/dir&quot; ) The generated file is returned in the as {:ok, filename} . The format of the file name is YYYYMMDDHHMMSS-metrics.mbf . See Mobius.Exports.parse_mbf/1 to parse a binary in MBF.","ref":"Mobius.Exports.html#mbf/1","title":"Mobius.Exports.mbf/1","type":"function"},{"doc":"Retrieve the raw metric data from the history store for a given metric. Output will be a list of metric values, which will be in the format, eg: %{type: :last_value, value: 12, tags: %{interface: &quot;eth0&quot;}, timestamp: 1645107424} If there are tags for the metric you can pass those in the third argument: Mobius.Exports . metrics ( &quot;vm.memory.total&quot; , :last_value , %{ some : :tag } ) By default the filter will display the last 3 minutes of metric history. However, you can pass the :from and :to options to look at a specific range of time. Mobius.Exports . metrics ( &quot;vm.memory.total&quot; , :last_value , %{ } , from : 1630619212 , to : 1630619219 ) You can also filter data over the last x amount of time. Where x is an integer. When there is no time_unit() provided the unit is assumed to be :second . Retrieving data over the last 30 seconds: Mobius.Exports . metrics ( &quot;vm.memory.total&quot; , :last_value , %{ } , last : 30 ) Retrieving data over the last 2 hours: Mobius.Exports . metrics ( &quot;vm.memory.total&quot; , :last_value , %{ } , last : { 2 , :hour } )","ref":"Mobius.Exports.html#metrics/4","title":"Mobius.Exports.metrics/4","type":"function"},{"doc":"Parse the mobius binary format into a list of metrics","ref":"Mobius.Exports.html#parse_mbf/1","title":"Mobius.Exports.parse_mbf/1","type":"function"},{"doc":"Plot the metric name to the screen This takes the same arguments as for filter_metrics, eg: If there are tags for the metric you can pass those in the second argument: Mobius.Exports . plot ( &quot;vm.memory.total&quot; , :last_value , %{ some : :tag } ) By default the plot will display the last 3 minutes of metric history. However, you can pass the :from and :to options to look at a specific range of time. Mobius.Exports . plot ( &quot;vm.memory.total&quot; , :last_value , %{ } , from : 1630619212 , to : 1630619219 ) You can also plot data over the last x amount of time. Where x is an integer. When there is no time_unit() provided the unit is assumed to be :second . Plotting data over the last 30 seconds: Mobius.Export . plot ( &quot;vm.memory.total&quot; , :last_value , %{ } , last : 30 ) Plotting data over the last 2 hours: Mobius.Export . plot ( &quot;vm.memory.total&quot; , :last_value , %{ } , last : { 2 , :hour } )","ref":"Mobius.Exports.html#plot/4","title":"Mobius.Exports.plot/4","type":"function"},{"doc":"Generates a series that contains the value of the metric","ref":"Mobius.Exports.html#series/4","title":"Mobius.Exports.series/4","type":"function"},{"doc":"Options for exporting a CSV","ref":"Mobius.Exports.html#t:csv_export_opt/0","title":"Mobius.Exports.csv_export_opt/0","type":"type"},{"doc":"Options to use when exporting time series metric data :mobius_instance - the name of the Mobius instance you are using. Unless you specified this in your configuration you should be safe to allow this option to default, which is :mobius_metrics . :last - display data point that have been captured over the last x amount of time. Where x is either an integer or a tuple of {integer(), time_unit()} . If you only pass an integer the time unit of :seconds is assumed. By default Mobius will plot the last 3 minutes of data. :from - the unix timestamp, in seconds, to start querying from :to - the unix timestamp, in seconds, to stop querying at","ref":"Mobius.Exports.html#t:export_opt/0","title":"Mobius.Exports.export_opt/0","type":"type"},{"doc":"","ref":"Mobius.Exports.html#t:mfb_export_opt/0","title":"Mobius.Exports.mfb_export_opt/0","type":"type"},{"doc":"A round robin database for Mobius This is RRD is used by Mobius to store historical metric data. A round robin database (RRD) is a data store that a circular buffer to store information. As time moves forward the older data points get overwritten by newer data points. This type of data storage is useful for a consistent memory footprint for time series data. The Mobius.RRD implementation provides four resolutions. These are: seconds, minutes, hours, and days. Each resolution can be configured to allow for as many single data points as you see fit. For example, if you want to store three days of data at an hour resolution you can configure the RRD like so: RRD . new ( hours : 72 ) The above will configure the hour resolution to store 72 hours worth of data points in the hour archive. The default resolutions are: 60 days (each day for about 2 months) 48 hours (each hour for 2 days) 120 minutes (each minute for 2 hours) 120 seconds (each second for 2 minutes) For more information about round robin databases, RRD tool is a great resource to study.","ref":"Mobius.RRD.html","title":"Mobius.RRD","type":"module"},{"doc":"Return all items in order","ref":"Mobius.RRD.html#all/1","title":"Mobius.RRD.all/1","type":"function"},{"doc":"Insert an item for the specified time","ref":"Mobius.RRD.html#insert/3","title":"Mobius.RRD.insert/3","type":"function"},{"doc":"Load persisted data back into a TimeLayerBuffer The rrd that's passed in is expected to be a new one without any entries.","ref":"Mobius.RRD.html#load/2","title":"Mobius.RRD.load/2","type":"function"},{"doc":"Create a new RRD The default resolution values are: 60 days (each day for about 2 months) 48 hours (each hour for 2 days) 120 minutes (each minute for 2 hours) 120 seconds (each second for 2 minutes)","ref":"Mobius.RRD.html#new/1","title":"Mobius.RRD.new/1","type":"function"},{"doc":"Return all items with timestamps equal to or after the specified one","ref":"Mobius.RRD.html#query/2","title":"Mobius.RRD.query/2","type":"function"},{"doc":"Return all items within the specified range","ref":"Mobius.RRD.html#query/3","title":"Mobius.RRD.query/3","type":"function"},{"doc":"Serialize to an iolist","ref":"Mobius.RRD.html#save/2","title":"Mobius.RRD.save/2","type":"function"},{"doc":"Options for the RRD For resolution options you specify which resolution and the max number of metric data to keep for that resolution. For example, if the RRD were to track seconds up to five minutes it would need to track 300 seconds. Also, if the same RRD wanted to track day resolution for a year, it would need to be contain 365 days. Mobius.RRD . new ( seconds : 300 , days : 365 )","ref":"Mobius.RRD.html#t:create_opt/0","title":"Mobius.RRD.create_opt/0","type":"type"},{"doc":"Resolution name","ref":"Mobius.RRD.html#t:resolution/0","title":"Mobius.RRD.resolution/0","type":"type"},{"doc":"Options for saving RRD into a binary :serialization_version - the version of serialization format, defaults to most recent","ref":"Mobius.RRD.html#t:save_opt/0","title":"Mobius.RRD.save_opt/0","type":"type"},{"doc":"","ref":"Mobius.RRD.html#t:t/0","title":"Mobius.RRD.t/0","type":"opaque"},{"doc":"Used when there is problem loading data into the mobius storage","ref":"Mobius.DataLoadError.html","title":"Mobius.DataLoadError","type":"exception"},{"doc":"Options for making a DataLoadError :reason - the reason why the data could not be loaded","ref":"Mobius.DataLoadError.html#t:opt/0","title":"Mobius.DataLoadError.opt/0","type":"type"},{"doc":"","ref":"Mobius.DataLoadError.html#t:t/0","title":"Mobius.DataLoadError.t/0","type":"type"},{"doc":"Use when there is an error parsing a Mobius Binary Format (MBF) binary","ref":"Mobius.Exports.MBFParseError.html","title":"Mobius.Exports.MBFParseError","type":"exception"},{"doc":"","ref":"Mobius.Exports.MBFParseError.html#t:t/0","title":"Mobius.Exports.MBFParseError.t/0","type":"type"},{"doc":"Error for trying to export metric types where there is no support in the export implementation","ref":"Mobius.Exports.UnsupportedMetricError.html","title":"Mobius.Exports.UnsupportedMetricError","type":"exception"},{"doc":"","ref":"Mobius.Exports.UnsupportedMetricError.html#t:t/0","title":"Mobius.Exports.UnsupportedMetricError.t/0","type":"type"},{"doc":"Used when there is an error conducting file operations","ref":"Mobius.FileError.html","title":"Mobius.FileError","type":"exception"},{"doc":"","ref":"Mobius.FileError.html#t:t/0","title":"Mobius.FileError.t/0","type":"type"},{"doc":"Library for localized telemetry metrics","ref":"readme.html","title":"Mobius","type":"extras"},{"doc":"def deps do [ { :mobius , &quot;~&gt; 0.4.0&quot; } ] end","ref":"readme.html#installation","title":"Mobius - Installation","type":"extras"},{"doc":"Add Mobius to your supervision tree and pass in the metrics you want to track. def start ( _type , _args ) do metrics = [ Metrics . last_value ( &quot;my.telemetry.event&quot; ) , ] children = [ # ... other children .... { Mobius , metrics : metrics } # ... other children .... ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Quick tips To see a view of the current metrics you can use Mobius.info/0 : iex&gt; Mobius . info ( ) Metric Name : vm . memory . total Tags : %{ } last_value : 83952736 To plot a metric measurement over time you can use: Mobius.Exports.plot/4 : iex&gt; Mobius.Exports . plot ( &quot;vm.memory.total&quot; , :last_value , %{ } ) Metric Name : vm . memory . total , Tags : %{ } 34355808.00 ┤ 34253736.73 ┤ ╭ ─ ─ ╮ ╭ ─ ─ ─ ─ ╮ 34151665.45 ┤ ╭ ─ ─ ─ ─ ╯ ╰ ─ ─ ─ ─ ╯ ╰ ─ ─ ─ 34049594.18 ┤ ╭ ─ ─ ─ ─ ╮ ╭ ─ ─ ─ ─ ╮ ╭ ─ ─ ─ ─ ╯ 33947522.91 ┤ │ ╰ ─ ─ ─ ─ ╯ ╰ ─ ╯ 33845451.64 ┤ │ 33743380.36 ┤ ╭ ─ ─ ─ ─ ╯ 33641309.09 ┤ │ 33539237.82 ┤ │ 33437166.55 ┤ │ 33335095.27 ┼ ─ ─ ─ ─ ╯ Configure persistence directory By default Mobius will try to save metric data for all resolutions and the current value when the erlang system exists gracefully. This makes Mobius useful for Nerves devices that have to reboot after doing a planned firmware update. The default direction Mobius will try to persist data to is the /data directory as this is friendly to Nerves devices. If you want Mobius to store data in a different location you can pass that into Mobius when you start it: children = [ # ... other children ... { Mobius , metrics : metrics ( ) , persistence_dir : &quot;/tmp&quot; } # ... other children ... ] def metrics ( ) do [ Metrics . last_value ( &quot;vm.memory.total&quot; , unit : { :byte , :kilobyte } ) ] end Saving / Autosaving metrics data By default the metrics data is persisted on a normal shutdown. However, data will not be persisted during a sudden shutdown, eg Control-C in IEX, kill, sudden power off. It's possible to manually call Mobius.save/1 to force an interim write of the persistence data. This can be automated by passing autosave_interval to Mobius def start ( _type , _args ) do metrics = [ Metrics . last_value ( &quot;my.telemetry.event&quot; ) , ] children = [ # ... other children .... { Mobius , metrics : metrics , autosave_interval : 60 } # auto save every 60 seconds # ... other children .... ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Exporting data The Mobius.Exports module provide functions for exporting the data in a couple different formats. CSV Series Line plot Mobius Binary Format # export as CSV string Mobius.Exports . csv ( &quot;vm.memory.total&quot; , :last_value , %{ } ) # export as series list Mobius.Exports . series ( &quot;vm.memory.total&quot; , :last_value , %{ } ) # export as mobius binary format Mobius.Exports . mbf ( ) The Mobius Binary Format (MBF) is a binary string that has encoded and compressed the all the historical metrics that mobius current has. This is most useful for preparing metrics to send off to another system. To parse the binary format you can use Mobius.Exports.parse_mbf/1 . For each of these you can see the Mobius.Exports module for more details.","ref":"readme.html#usage","title":"Mobius - Usage","type":"extras"},{"doc":"This project follows Semantic Versioning . Major version zero (0.y.z) is for initial development. Anything MAY change at any time. The public API SHOULD NOT be considered stable.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changed Mobius.plot/3 is now Mobius.Exports.plot/4 Mobius.to_csv/3 is now Mobius.Exports.csv/4 Mobius.filter_metrics/3 is now Mobius.Exports.metrics/4 Mobius.name() is now Mobius.instance() Mobius functions that need to know the name of the mobius instance now expect :mobius_instance and not :name Mobius.metric_name() is no longer a list of atoms() but is not the metric name as a string Mobius.RRD internal metric format Mobius.RRD.insert/3 typespec now expects [Mobius.metric()] as the last parameter Removed Mobius.filter_opt() type Mobius.csv_opt() type Mobius.plot_opt() type Mobius.query_opts/1 function Mobius.to_csv/3 function Mobius.plot/3 function Mobius.filter_metrics/3 function Mobius.make_bundle/2 function (use Mobius.mbf/1 instead) Mobius.Bundle module Mobius.record() type Added Mobius.Exports module for APIs concerning retrieving historical data in various formats Mobius.Exports.csv/4 generates a CSV either as a string, to the console, or to a file Mobius.Exports.series/4 generates a series for historical data Mobius.Exports.metrics/4 retrieves the raw historical metric data Mobius.Exports.plot/4 generates a line plot to the console Mobius.Exports.mbf/1 generates a binary that contains all current metrics Mobius.Exports.parse_mbf/1 parses a binary that is in the Mobius Binary Format Mobius.Exports.UnsupportedMetricError Mobius.Exports.MBFParseError Mobius.FileError :name field to Mobius.metric() type","ref":"changelog.html#v0-4-0-2022-03-25","title":"Changelog - v0.4.0 - 2022-03-25","type":"extras"},{"doc":"This release brings in a bunch of new functionality and bug fixes. Along with basic maintenance like dependency updates and documentation improvements (@ewildgoose). Added Create, save, and extract tar files that contain metric data, see Mobius.Bundles and Mobius.make_bundle/2 for more information. Mobius.filter_metrics/3 to filter for desired metrics to enable the metrics to be consumed externally (@ewildgoose) Mobius.save/1 to manually save the state of the metric data for Mobius (@ewildgoose) :autosave_interval option to Mobius to enable a saving data at the given interval (@ewildgoose) Fixes Unit conversion not working correctly (@ewildgoose) Error handling for when the :persistence_path is missing (@ewildgoose) Error handling when there is no data to plot (@ewildgoose) Crash when plotting an array of identical values (@ewildgoose) Correct off by one error when plotting (@ewildgoose)","ref":"changelog.html#v0-3-7-2022-03-16","title":"Changelog - v0.3.7 - 2022-03-16","type":"extras"},{"doc":"Added Support for Telemetry.Metrics.Summary metric type","ref":"changelog.html#v0-3-6-2022-01-25","title":"Changelog - v0.3.6 - 2022-01-25","type":"extras"},{"doc":"Fixes Fix crash when initializing metrics table when the ETS file cannot be read (@jfcloutier)","ref":"changelog.html#v0-3-5-2021-12-2","title":"Changelog - v0.3.5 - 2021-12-2","type":"extras"},{"doc":"Fixes Fix crash when a history file is unreadable during initialization (@mdwaud)","ref":"changelog.html#v0-3-4-2021-11-15","title":"Changelog - v0.3.4 - 2021-11-15","type":"extras"},{"doc":"Fixes Not able to pass a path for persistence that contains non-existing sub directories. Thank you LostKobrakai .","ref":"changelog.html#v0-3-3-2021-10-20","title":"Changelog - v0.3.3 - 2021-10-20","type":"extras"},{"doc":"Added Support for Telemetry.Metrics.Sum type Support for filtering CSV records by type with :type option","ref":"changelog.html#v0-3-2-2021-09-22","title":"Changelog - v0.3.2 - 2021-09-22","type":"extras"},{"doc":"Added Plot over the last x seconds via the :last plot option Plot from an absolute time via the :from plot option Plot to an absolute time via the :to plot option Print or save metric time series via Mobius.to_csv/3 Remove tracking a metric by dropping it from the metric list passed to Mobius Changed Mobius.plot/3 will only show the last 3 minutes of data by default","ref":"changelog.html#v0-3-1-2021-09-08","title":"Changelog - v0.3.1 - 2021-09-08","type":"extras"},{"doc":"Changed Deleted Mobius.Charts module. The functions in this module are now located in the Mobius module. Removed Support for specifying resolutions.","ref":"changelog.html#v0-3-0-2021-8-19","title":"Changelog - v0.3.0 - 2021-8-19","type":"extras"},{"doc":"Added Mobius.Charts module Persistence of historical information on graceful shutdown Ability to specify time resolutions for plots Changed Move Moblus.plot/0 and Mobius.info/0 to Mobius.Charts module","ref":"changelog.html#v0-2-0-2021-8-03","title":"Changelog - v0.2.0 - 2021-8-03","type":"extras"},{"doc":"Initial release!","ref":"changelog.html#v0-1-0-2021-7-16","title":"Changelog - v0.1.0 - 2021-7-16","type":"extras"}]